//----------------------------------------------------------------------------
// RChart.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: RChart.pas
//----------------------------------------------------------------------------
#ifndef RChartHPP
#define RChartHPP
//----------------------------------------------------------------------------
#include <RCCommon.hpp>
#include <DsgnIntf.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Menus.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysUtils.hpp>
#include <System.hpp>
namespace Rchart
{
//-- type declarations -------------------------------------------------------
enum FigType { ftNoFigs, ftNum, ftTime, ftNoScales, ftDateTime };

enum GridStyleType { gsNone, gsPoints, gsVertLines, gsHorizLines, gsLines, gsHorizDotLines, gsVertDotLines, 
	gsDotLines };

enum TShadowStyle { ssFlying, ssBox };

enum TTextBkg { tbClear, tbSolid };

typedef SmallString<50>  LabelStr;

typedef SmallString<15>  InscriptStr;

enum ZoomStateType { zsNormal, zsDrawWin };

enum MouseBoxStateType { msNormal, msFirstCorner, msRectDraw, msFinished };

enum MouseActMode { maNone, maPan, maZoomWind, maZoomWindPos, maZoomDrag };

typedef void __fastcall (__closure *TMouseMoveInChartEvent)(System::TObject* Sender, bool InChart, Classes::TShiftState 
	Shift, double rMousePosX, double rMousePosY);

class __declspec(delphiclass) TRChart;
class __declspec(pascalimplementation) TRChart : public Controls::TGraphicControl
{
	typedef Controls::TGraphicControl inherited;
	
private:
	bool LButtonWasDown;
	int MouseAnchorScrX;
	int MouseAnchorScrY;
	double MouseAnchorRcLoX;
	double MouseAnchorRcLoY;
	double MouseAnchorRcHiX;
	double MouseAnchorRcHiY;
	ZoomStateType ZoomState;
	MouseBoxStateType MouseBoxState;
	int LastMouseX;
	int LastMouseY;
	int MouseBoxX1;
	int MouseBoxX2;
	int MouseBoxY1;
	int MouseBoxY2;
	int WindAnchorX;
	int WindAnchorY;
	int WindOldCornerX;
	int WindOldCornerY;
	TMouseMoveInChartEvent FOnMMvInChart;
	Graphics::TBitmap* AuxBmp;
	Graphics::TBitmap* GrafBmp;
	Graphics::TBitmap* ChartBmp;
	Rccommon::TBakGndImg* FBakGndFile;
	GridStyleType RcGridStyle;
	Graphics::TColor RcGridCol;
	double RcGridDx;
	double RcGridDy;
	int RcLRim;
	int RcRRim;
	int RcTRim;
	int RcBRim;
	int Rc3DRim;
	TShadowStyle RcShadowStyle;
	Graphics::TColor RcShadowColor;
	Graphics::TColor RcShadowBakCol;
	bool RcShortTicksX;
	bool RcShortTicksY;
	bool RcXLog;
	bool RcYLog;
	MouseActMode RcMouseAction;
	Rccommon::TDrawCan *RcFrstCan;
	Rccommon::TDrawCan *RcLastCan;
	Rccommon::TDrawCan *RcLastCanOnShow;
	Graphics::TColor RcDataCol;
	Graphics::TColor RcScaleCol;
	Graphics::TColor RcFillCol;
	Graphics::TColor RcChartCol;
	Graphics::TColor RcWindCol;
	Byte RcLineWid;
	System::AnsiString TitStr;
	InscriptStr RcScaleInscrX;
	InscriptStr RcScaleInscrY;
	double RcBndLoX;
	double RcBndLoY;
	double RcBndHiX;
	double RcBndHiY;
	Byte RcClassDefault;
	int RcDecPlcX;
	int RcDecPlcY;
	double Cpkx;
	double Cpdx;
	double Cpky;
	double Cpdy;
	LabelStr RcXUnits;
	LabelStr RcYUnits;
	int RcXNtick;
	int RcYNtick;
	FigType RcXLabelType;
	FigType RcYLabelType;
	double FMousePosX;
	double FMousePosY;
	Rccommon::TDTLabel* FDTXFormat;
	Rccommon::TDTLabel* FDTYFormat;
	bool FMCurFixed;
	bool FAutoRedraw;
	long FNumPPa;
	Graphics::TFontStyles FTextFontStyle;
	TTextBkg FTextBkStyle;
	Graphics::TColor FTextBkColor;
	virtual void __fastcall AdjustScaling(void);
	System::AnsiString __fastcall AddScaleInscription( System::AnsiString p0,  InscriptStr &p1);
	void __fastcall ConstructChartBmp(Graphics::TCanvas* p0);
	void __fastcall ConstructDataBmp(bool p0, Rccommon::PDrawCan p1);
	void __fastcall ForceRange(double p0, double p1, double p2, double p3);
	Rccommon::ItemType __fastcall GetTypeOfFirstItem(void);
	Rccommon::ItemType __fastcall GetTypeOfLastItem(void);
	Rccommon::PDrawCan __fastcall GetFirstItemLL(void);
	void __fastcall InitGraf(void);
	void __fastcall SetLRim(int p0);
	void __fastcall SetRRim(int p0);
	void __fastcall SetTRim(int p0);
	void __fastcall SetBRim(int p0);
	void __fastcall SetRc3DRim(int p0);
	void __fastcall SetShadowStyle(TShadowStyle p0);
	void __fastcall SetShadowColor(Graphics::TColor p0);
	void __fastcall SetShadowBakColor(Graphics::TColor p0);
	void __fastcall SetClassDefault(Byte p0);
	void __fastcall SetDecPlcX(int p0);
	void __fastcall SetDecPlcY(int p0);
	void __fastcall SetGridStyle(GridStyleType p0);
	void __fastcall SetGridDx(double p0);
	void __fastcall SetGridDy(double p0);
	void __fastcall SetDataCol(Graphics::TColor p0);
	void __fastcall SetScaleCol(Graphics::TColor p0);
	void __fastcall SetFillCol(Graphics::TColor p0);
	void __fastcall SetChartCol(Graphics::TColor p0);
	void __fastcall SetWindCol(Graphics::TColor p0);
	void __fastcall SetGridCol(Graphics::TColor p0);
	void __fastcall SetTitStr( System::AnsiString p0);
	void __fastcall SetLineWid(Byte p0);
	void __fastcall SetXUnits( LabelStr &p0);
	void __fastcall SetYUnits( LabelStr &p0);
	void __fastcall SetShortTicksX(bool p0);
	void __fastcall SetShortTicksY(bool p0);
	void __fastcall SetRcXLog(bool p0);
	void __fastcall SetRcYLog(bool p0);
	void __fastcall SetBndLoX(double p0);
	void __fastcall SetBndHiX(double p0);
	void __fastcall SetBndLoY(double p0);
	void __fastcall SetBndHiY(double p0);
	void __fastcall SetDTXFormat(Rccommon::TDTLabel* p0);
	void __fastcall SetDTYFormat(Rccommon::TDTLabel* p0);
	MESSAGE void __fastcall WMMouseMoveInChart(Messages::TWMMouse &RChart_);
	void __fastcall SetXNTick(int p0);
	void __fastcall SetYNTick(int p0);
	void __fastcall SetTextFontStyle(Graphics::TFontStyles p0);
	void __fastcall SetTextBkStyle(TTextBkg p0);
	void __fastcall SetTextBkColor(Graphics::TColor p0);
	void __fastcall SetXLabType(FigType p0);
	void __fastcall SetYLabType(FigType p0);
	void __fastcall SetScaleInscrX( InscriptStr &p0);
	void __fastcall SetScaleInscrY( InscriptStr &p0);
	void __fastcall SetBakGndFile(Rccommon::TBakGndImg* p0);
	
protected:
	virtual void __fastcall Paint(void);
	virtual void __fastcall MouseMove(Classes::TShiftState p0, int p1, int p2);
	void __fastcall MouseMoveInChart(bool p0, Classes::TShiftState p1, double p2, double p3);
	virtual void __fastcall MouseDown(Controls::TMouseButton p0, Classes::TShiftState p1, int p2, int p3
		);
	void __fastcall StyleChanged(System::TObject* p0);
	virtual void __fastcall SetBounds(int p0, int p1, int p2, int p3);
	
public:
	__fastcall virtual TRChart(Classes::TComponent* p0);
	__fastcall virtual ~TRChart(void);
	void __fastcall M2R(long p0, long p1, double &p2, double &p3);
	void __fastcall R2M(double p0, double p1, long &p2, long &p3);
	void __fastcall ClearGraf(void);
	void __fastcall ShowGraf(void);
	void __fastcall ShowGrafNewOnly(void);
	bool __fastcall MouseBox(double &p0, double &p1, double &p2, double &p3);
	void __fastcall Bar3D(double p0, double p1, double p2, double p3, int p4, int p5);
	void __fastcall CopyToBMP( System::AnsiString p0);
	void __fastcall CopyToClipboard(void);
	void __fastcall CopyToOpenPrinter(int &p0, int &p1, double p2, bool p3);
	void __fastcall DrawTo(double p0, double p1);
	void __fastcall Ellipse(double p0, double p1, double p2, double p3);
	void __fastcall Line(double p0, double p1, double p2, double p3);
	void __fastcall MoveTo(double p0, double p1);
	void __fastcall MarkAt(double p0, double p1, Byte p2);
	void __fastcall PrintIt(double p0, bool p1);
	void __fastcall Rectangle(double p0, double p1, double p2, double p3);
	void __fastcall RectFrame(double p0, double p1, double p2, double p3, Rccommon::TRFrameStyle p4, Graphics::TColor 
		p5, Graphics::TColor p6);
	void __fastcall SaveLinkedListASC( System::AnsiString p0);
	void __fastcall SaveLinkedList( System::AnsiString p0);
	void __fastcall LoadLinkedList( System::AnsiString p0, bool p1);
	void __fastcall SetRange(double p0, double p1, double p2, double p3);
	void __fastcall AutoRange(double p0);
	HIDESBASE void __fastcall Text(double p0, double p1, int p2,  System::AnsiString p3);
	void __fastcall RemoveLastItem(void);
	void __fastcall RemoveFirstItem(void);
	Rccommon::PDrawCan __fastcall FindNearestItemReal(double p0, double p1, Rccommon::ItemType p2, Byte 
		p3, double &p4);
	Rccommon::PDrawCan __fastcall FindNearestItemScreen(double p0, double p1, Rccommon::ItemType p2, Byte 
		p3, double &p4);
	__property Rccommon::PDrawCan FirstItemOfLinkedList = {read=GetFirstItemLL, nodefault};
	Rccommon::TDrawCan __fastcall GetItemParams(Rccommon::PDrawCan p0);
	void __fastcall SetItemParams(Rccommon::PDrawCan p0, const Rccommon::TDrawCan &RChart_);
	void __fastcall ScaleItem(Rccommon::PDrawCan p0, double p1, double p2, double p3, double p4);
	long __fastcall MarkItemsInWindow(double p0, double p1, double p2, double p3, Rccommon::ItemType p4
		, Byte p5);
	void __fastcall MarkAllItems(Rccommon::ItemType p0, Byte p1);
	void __fastcall ScaleAllItems(double p0, double p1, double p2, double p3);
	void __fastcall ScaleSelectedItems(double p0, double p1, double p2, double p3, Byte p4);
	__property Rccommon::ItemType TypeOfLastItem = {read=GetTypeOfLastItem, nodefault};
	__property Rccommon::ItemType TypeOfFirstItem = {read=GetTypeOfFirstItem, nodefault};
	void __fastcall NewColorOfClassItems(Graphics::TColor p0, Byte p1);
	
__published:
	__property Font ;
	__property Align ;
	__property Visible ;
	__property ShowHint ;
	__property PopupMenu ;
	__property bool AutoRedraw = {read=FAutoRedraw, write=FAutoRedraw, nodefault};
	__property int LRim = {read=RcLRim, write=SetLRim, default=50};
	__property int RRim = {read=RcRRim, write=SetRRim, default=10};
	__property int TRim = {read=RcTRim, write=SetTRim, default=16};
	__property int BRim = {read=RcBRim, write=SetBRim, default=32};
	__property Rccommon::TBakGndImg* BackGroundImg = {read=FBakGndFile, write=SetBakGndFile, nodefault}
		;
	__property Byte ClassDefault = {read=RcClassDefault, write=SetClassDefault, nodefault};
	__property int DecPlaceX = {read=RcDecPlcX, write=SetDecPlcX, default=1};
	__property int DecPlaceY = {read=RcDecPlcY, write=SetDecPlcY, default=1};
	__property GridStyleType GridStyle = {read=RcGridStyle, write=SetGridStyle, nodefault};
	__property double GridDx = {read=RcGridDx, write=SetGridDx};
	__property double GridDy = {read=RcGridDy, write=SetGridDy};
	__property double RangeLoX = {read=RcBndLoX, write=SetBndLoX};
	__property double RangeHiX = {read=RcBndHiX, write=SetBndHiX};
	__property double RangeLoY = {read=RcBndLoY, write=SetBndLoY};
	__property double RangeHiY = {read=RcBndHiY, write=SetBndHiY};
	__property Graphics::TColor DataColor = {read=RcDataCol, write=SetDataCol, default=0};
	__property Graphics::TColor ScaleColor = {read=RcScaleCol, write=SetScaleCol, default=0};
	__property Graphics::TColor FillColor = {read=RcFillCol, write=SetFillCol, default=12632256};
	__property Graphics::TColor ChartColor = {read=RcChartCol, write=SetChartCol, default=16777215};
	__property Graphics::TColor WindColor = {read=RcWindCol, write=SetWindCol, default=12632256};
	__property Graphics::TColor GridColor = {read=RcGridCol, write=SetGridCol, default=0};
	__property Byte LineWidth = {read=RcLineWid, write=SetLineWid, default=1};
	__property System::AnsiString Caption = {read=TitStr, write=SetTitStr, nodefault};
	__property LabelStr IdAbscissa = {read=RcXUnits, write=SetXUnits};
	__property LabelStr IdOrdinate = {read=RcYUnits, write=SetYUnits};
	__property InscriptStr ScaleInscriptX = {read=RcScaleInscrX, write=SetScaleInscrX};
	__property InscriptStr ScaleInscriptY = {read=RcScaleInscrY, write=SetScaleInscrY};
	__property bool LogScaleX = {read=RcXLog, write=SetRcXLog, nodefault};
	__property bool LogScaleY = {read=RcYLog, write=SetRcYLog, nodefault};
	__property int MinTickX = {read=RcXNtick, write=SetXNTick, default=3};
	__property int MinTickY = {read=RcYNtick, write=SetYNTick, default=3};
	__property double MousePosX = {read=FMousePosX};
	__property double MousePosY = {read=FMousePosY};
	__property MouseActMode MouseAction = {read=RcMouseAction, write=RcMouseAction, nodefault};
	__property bool MouseCursorFixed = {read=FMCurFixed, write=FMCurFixed, nodefault};
	__property int ShadowWidth = {read=Rc3DRim, write=SetRc3DRim, default=0};
	__property TShadowStyle ShadowStyle = {read=RcShadowStyle, write=SetShadowStyle, nodefault};
	__property Graphics::TColor ShadowColor = {read=RcShadowColor, write=SetShadowColor, nodefault};
	__property Graphics::TColor ShadowBakColor = {read=RcShadowBakCol, write=SetShadowBakColor, nodefault
		};
	__property bool ShortTicksX = {read=RcShortTicksX, write=SetShortTicksX, nodefault};
	__property bool ShortTicksY = {read=RcShortTicksY, write=SetShortTicksY, nodefault};
	__property Graphics::TFontStyles TextFontStyle = {read=FTextFontStyle, write=SetTextFontStyle, nodefault
		};
	__property TTextBkg TextBkStyle = {read=FTextBkStyle, write=SetTextBkStyle, nodefault};
	__property Graphics::TColor TextBkColor = {read=FTextBkColor, write=SetTextBkColor, nodefault};
	__property FigType XLabelType = {read=RcXLabelType, write=SetXLabType, nodefault};
	__property FigType YLabelType = {read=RcYLabelType, write=SetYLabType, nodefault};
	__property Rccommon::TDTLabel* DTXFormat = {read=FDTXFormat, write=SetDTXFormat, nodefault};
	__property Rccommon::TDTLabel* DTYFormat = {read=FDTYFormat, write=SetDTYFormat, nodefault};
	__property OnClick ;
	__property OnDblClick ;
	__property OnMouseMove ;
	__property OnMouseDown ;
	__property OnMouseUp ;
	__property TMouseMoveInChartEvent OnMouseMoveInChart = {read=FOnMMvInChart, write=FOnMMvInChart};
};

//-- var, const, procedure ---------------------------------------------------
#define defLRim (Byte)(50)
#define defRRim (Byte)(10)
#define defTRim (Byte)(16)
#define defBRim (Byte)(32)
#define defShadowWidth (Byte)(0)
#define defDataCol (int)(0)
#define defScaleCol (int)(0)
#define defFillCol (int)(12632256)
#define defChartCol (int)(16777215)
#define defWindCol (int)(12632256)
#define defGridCol (int)(0)
#define defLineWid (Byte)(1)
#define defHeight (Byte)(160)
#define defWidth (Byte)(240)
extern double defBndLoX;
extern double defBndLoY;
extern double defBndHiX;
extern double defBndHiY;
#define defDecPlcX (Byte)(1)
#define defDecPlcY (Byte)(1)
#define defNXTick (Byte)(3)
#define defNYTick (Byte)(3)
#define MaxRCMarks (Byte)(25)
#define MinWidth (Byte)(50)
#define MinHeight (Byte)(10)
extern void __fastcall Register(void);
//-- template instantiations -------------------------------------------------
template class Graphics::TFontStyles ;
template class SmallString<15> ;
template class SmallString<50> ;

}	/* namespace Rchart */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Rchart;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// RChart
